'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  display: block;\n  margin: 1em auto;\n  width: 100%;\n  height: 6em;\n\n  circle {\n    fill: none;\n    stroke-width: 20;\n    transform: translate(100px, 100px) rotate(-89.9deg);\n    transition: stroke-dashoffset 0.3s linear;\n  }\n\n  .arc-background {\n    stroke: ', ';\n  }\n\n  .arc {\n    stroke: ', ';\n    stroke-linecap: ', '\n  }\n\n  text {\n    fill: ', ';\n    font-size: 50px;\n    font-weight: 600;\n    text-anchor: middle;\n  }\n'], ['\n  display: block;\n  margin: 1em auto;\n  width: 100%;\n  height: 6em;\n\n  circle {\n    fill: none;\n    stroke-width: 20;\n    transform: translate(100px, 100px) rotate(-89.9deg);\n    transition: stroke-dashoffset 0.3s linear;\n  }\n\n  .arc-background {\n    stroke: ', ';\n  }\n\n  .arc {\n    stroke: ', ';\n    stroke-linecap: ', '\n  }\n\n  text {\n    fill: ', ';\n    font-size: 50px;\n    font-weight: 600;\n    text-anchor: middle;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Svg = _styledComponents2.default.svg(_templateObject, function (props) {
  return props.arcBackgroundColor;
}, function (props) {
  return props.arcColor;
}, function (props) {
  return props.rounded ? 'round' : 'inherit';
}, function (props) {
  return props.textColor;
});

function ProgressArc(_ref) {
  var value = _ref.value,
      max = _ref.max,
      className = _ref.className,
      unit = _ref.unit,
      arcColor = _ref.arcColor,
      arcBackgroundColor = _ref.arcBackgroundColor,
      textColor = _ref.textColor,
      textVisible = _ref.textVisible,
      radius = _ref.radius,
      rounded = _ref.rounded;

  var p = 2 * radius * Math.PI;
  return _react2.default.createElement(
    Svg,
    {
      className: className,
      arcColor: arcColor,
      arcBackgroundColor: arcBackgroundColor,
      textColor: textColor,
      rounded: rounded,
      viewBox: '0 0 200 200' },
    _react2.default.createElement('circle', {
      className: 'arc-background',
      r: radius }),
    _react2.default.createElement('circle', {
      className: 'arc',
      r: radius,
      strokeDashoffset: (max - value) / max * p,
      strokeDasharray: p
    }),
    textVisible ? _react2.default.createElement(
      'text',
      { x: '100', y: '115' },
      '' + value + unit
    ) : null
  );
}

ProgressArc.propTypes = {
  value: _react.PropTypes.number.isRequired,
  max: _react.PropTypes.number,
  unit: _react.PropTypes.string,
  arcColor: _react.PropTypes.string,
  arcBackgroundColor: _react.PropTypes.string,
  textColor: _react.PropTypes.string,
  textVisible: _react.PropTypes.bool,
  radius: _react.PropTypes.number,
  rounded: _react.PropTypes.bool
};

ProgressArc.defaultProps = {
  value: 0,
  max: 100,
  unit: '%',
  arcColor: '#818a91',
  arcBackgroundColor: '#eceeef',
  textColor: '#818a91',
  textVisible: true,
  radius: 90,
  rounded: false
};

exports.default = ProgressArc;